﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Ogc.Wms
{
    public class Request : WmsModel
    {
        public Request(XmlElement dataNode)
        {
            this.dataNode = dataNode;
        }

        public RequestItem AddItem(string name)
        {
            return CreateChild<RequestItem>(name);
        }

        public RequestItem[] Items
        {
            get
            {
                return GetChildren<RequestItem>("*");
            }
        }
    }

    public class RequestItem : WmsModel
    {
        public RequestItem(XmlElement dataNode)
        {
            this.dataNode = dataNode;
        }

        public void AddFormat(string value)
        {
            AddNodeInnerText("Format", value);
        }

        public string[] Formats
        {
            get
            {
                return GetTextArray("Format");
            }
        }
    }
}
